#!/usr/local/bin/perl
use strict;
use warnings;

open my $fh, '<', 'oscars.txt' or die "Cannot open input: $!\n";
my %award_count;
my %movie;
my $year;
while ( <$fh> )
{
  chomp;
  if ( /\A\d+\z/ )
  {
    $year = $_;
    %award_count = ();
    %movie = ();
  }
  elsif ( /---/ )
  {
    print "$year $_: $award_count{$_} for $movie{$_}\n"
      for grep { $award_count{$_} >= 3 } keys %award_count;
  }
  my ($for, $rest) = /([^:]+): (?:Written for )?(.*)/ or next;
  my @people;
  my $what;
  if ( $for =~ /\AAct/ )
  {
    (my $who, $what) = ( $rest =~ /(.*) as .*? in (.*)/ ) or next;
    @people = $who;
  }
  else
  {
    (my $list, $what) = ( $rest =~ /(.*?\S)\s+for (.*)/ ) or next;
    $list =~ s/, (Co-)?Producers?//g;
    @people = split /, | and | & |;\s+/, $list;
    s/.* by // for @people;
  }
  for my $who ( @people )
  {
    next if $movie{$who} && $movie{$who} ne $what;
    $award_count{$who}++;
    $movie{$who} = $what;
  }
}
