#!/usr/local/bin/perl
use strict;
use warnings;

use feature qw(state say);    # Perl 5.10

my $code_ref = \&random_color;

say $code_ref->( 'L' ) for 1 .. shift || 1;


sub random_color
{
  my $case = shift;

  state $colors_ref = read_colors();  # List context initialization of state variables currently forbidden

  my $color = $colors_ref->[ rand @$colors_ref ];
  return $case eq 'T' ? ucfirst( $color ) : $case eq 'U' ? uc( $color ) : lc( $color );
}

sub read_colors
{
  my @colors;
  open my $fh, '<', '/usr/share/X11/rgb.txt' or die "open: $!";
  chomp and push @colors, ( split ' ', $_, 4 )[3] while <$fh>;
  return \@colors;
}
