package Movie;

use Moose;   # Does use strict/warnings for us
use MooseX::StrictConstructor;
use MooseX::Method::Signatures;
use MooseX::ClassAttribute;
use namespace::autoclean;

with 'CreativeWork';

class_has movie_count => ( is => 'rw', isa => 'Int', default => 0 );

sub BUILD { __PACKAGE__->movie_count( __PACKAGE__->movie_count + 1 ) }

has actor => ( is => 'rw', isa => 'HashRef[Person]', default => sub { +{ } } );
has based_on => ( is => 'rw', isa => 'Book', handles => [ qw(author) ]  );

method leading_man( :$character!, :$actor! ) {
  $self->actor->{ $character } = $actor;
}

__PACKAGE__->meta->make_immutable;

1;
