#!/usr/local/bin/perl
use strict;
use warnings;

use Movie;
use Oscar;
use Person;
use Oscar::Ceremony;
use Book;

my $classic = Movie->new( title => 'Ben-Hur', genre => 'Drama' );
my $heston = Person->new( name => 'Charlton Heston' );
my $best_actor_1959 = Oscar->new( year => 1959, category => 'Best Actor', winner => $heston, for => $classic );
$classic->leading_man( character => 'Judah Ben-Hur', actor => $heston );

my $director = Person->new( name => 'Sam Zimbalist' );
my $best_picture_1959 = Oscar->new( year => 1959, category => 'Best Picture', winner => $director, for => $classic );

my $ceremony = Oscar::Ceremony->new( year => 1959, awards => [ $best_picture_1959, $best_actor_1959 ] );
print $ceremony->year, " Oscars were for: ", join( ', ' => $ceremony->movies ), "\n";

my $anne = Person->new( name => 'Anne Frank' );
my $diary = Book->new( author => $anne, title => 'The Diary of Anne Frank' );

my $winters = Person->new( name => 'Shelley Winters' );
my $d_o_af = Movie->new( title => 'The Diary of Anne Frank', genre => 'Biography', based_on => $diary );
print "Author of ", $d_o_af->title, " was ", $d_o_af->author->name, "\n";

my $best_supporting_actress_1959 = Oscar->new( year => 1959, category => 'Best Supporting Actress', winner => $winters, for => $d_o_af );
$ceremony->awards( [ $ceremony->awards, $best_supporting_actress_1959 ] );

print $ceremony->year, " Oscars were for: ", join( ', ' => $ceremony->movies ), "\n";

print "Have seen ", Movie->movie_count, " movies\n";

my $r_a_t_t = Movie->new( title => 'Room at the Top' );

print "Have seen ", Movie->movie_count, " movies\n";
