#!/usr/local/bin/perl
use strict;
use warnings;

use Text::CSV;
use DBI;

my $file = 'state.csv';
my $dbfile = 'state.db';
my $csv = Text::CSV->new ( { binary => 1, eol => $/ } );
open my $io, "<", $file or die "$file: $!";

{
  my $row = $csv->getline( $io );
  my @column_names = @$row;
  $csv->column_names( @column_names );
}

my $dbh = DBI->connect( "dbi:SQLite:dbname=$dbfile" );
$dbh->do( join '', <DATA> );

while ( my $h_ref = $csv->getline_hr( $io ) )
{
  $dbh->do( <<'EOSQL', undef, @$h_ref{qw(key name capital flower largest_city bird) } )
  INSERT INTO state( key, name, capital, flower, largest_city, bird )
VALUES ( ?, ?, ?, ?, ?, ?)
EOSQL
}

__END__
CREATE TABLE state (
  key VARCHAR(2),
  name VARCHAR(40),
  capital VARCHAR(40),
  flower VARCHAR(40),
  largest_city VARCHAR(40),
  bird VARCHAR(40)
 )
