#!/usr/local/bin/perl
use strict;
use warnings;

use feature qw(say);
use WWW::Mechanize;
use URI;
use HTML::TreeBuilder;

my $START = 'http://my.safaribooksonline.com/video';

my $mech = WWW::Mechanize->new;
my $tree = HTML::TreeBuilder->new;

$mech->get( $START );

# WWW::Mechanize doesn't recognize the TITLE attribute in A links
$tree->parse( $mech->content );

my ($link) = $tree->look_down( _tag => 'a', title => 'View All Videos' );
my $target = $link->attr( 'href' );

my $uri = URI->new_abs( $target, $mech->base );
$mech->get( $uri->as_string );
$tree->parse( $mech->content );

for my $elem ( $tree->look_down( _tag=> 'strong',
				 sub { my ($text) = $_[0]->content_list; $text && $text =~ /(?:Publication|Insert).*Date/ } ) )
{
  my ($date) = $elem->right->content_list;
  say $date;
}
